﻿Option Strict On
Option Explicit On

Imports System.Net.Sockets
Imports System.Text

Public Class Form1
#Region "Telemetry Functions"
    Private Telemetry_Sender As New UdpClient
    Private Telemetry_Loop_ms As Integer
    Private Telemetry_Running As Boolean = False
    Private Telemetry_Thread As Threading.Thread

    'Starts up the Telemetry Sender.
    Private Sub Start_Telemetry_Output()
        'only startup if not already started.
        If Telemetry_Running = False Then

            'read from Telemtry cfg file.
            Dim telemetry_Enabled As String = "Get Enabled_Telemetry value from the Telemetry.cfg file"
            Dim IpAddress As String = "Get IpAddress value from the Telemetry.cfg file"
            Dim Port As String = "Get Port value from the Telemetry.cfg file"
            Dim MS_OutputRate As String = "Get MS_OutputRate value from the Telemetry.cfg file"

            If CBool(telemetry_Enabled) = True Then
                Try
                    'startup a new client.
                    Telemetry_Sender = New UdpClient
                    Telemetry_Sender.Connect(IpAddress, CInt(Port))

                    'set loop speed & start sending data.
                    Telemetry_Loop_ms = CInt(MS_OutputRate)
                    Telemetry_Running = True
                    Telemetry_Thread = New Threading.Thread(AddressOf Telemetry_Loop)
                    Telemetry_Thread.IsBackground = True
                    Telemetry_Thread.Start()
                Catch ex As Exception
                    'Could not create the UDP sender, no need to do anything.
                End Try
            End If
        End If
    End Sub

    'Send Telemetry
    Public Sub SendTelemetry()
        Try
            'Collect the data.
            Dim Roll As String = ""
            Dim Pitch As String = ""
            Dim Yaw As String = ""
            Dim RollSpeed As String = ""
            Dim PitchSpeed As String = ""
            Dim YawSpeed As String = ""
            Dim Vertical As String = ""
            Dim Lateral As String = ""
            Dim Longitudinal As String = ""
            'add anything else you want to add, its easy now!
            'Dim Rpm As String = ""
            'Dim Speed As String = ""

            'check the status to see if the game is being played (In Game, In Menus, Paused).
            Dim Game_Is_Playing As Boolean = 'Get if the game is being played)

            'game is actually being played check.
            If Game_Is_Playing = True Then
                'If game is actually being played (not in Menus or paused).
                Roll = "Get value from your game" 'in degrees - (-180 to 180)
                Pitch = "Get value from your game" 'in degrees - (-180 to 180)
                Yaw = "Get value from your game" 'in degrees - (-180 to 180)
                RollSpeed = "Get value from your game" 'in (rad/sec)
                PitchSpeed = "Get value from your game" 'in (rad/sec)
                YawSpeed = "Get value from your game" 'in (rad/sec)
                Vertical = "Get value from your game" 'in g's acceleration
                Lateral = "Get value from your game" 'in g's acceleration
                Longitudinal = "Get value from your game" 'in g's acceleration
            Else
                'If the game is paused or in the Menus. (not actually being played)
                Roll = "0" 'in degrees - (-180 to 180)
                Pitch = "0" 'in degrees - (-180 to 180)
                Yaw = "0" 'in degrees - (-180 to 180)
                RollSpeed = "0" 'in (rad/sec)
                PitchSpeed = "0" 'in (rad/sec)
                YawSpeed = "0" 'in (rad/sec)
                Vertical = "0" 'in g's acceleration
                Lateral = "0" 'in g's acceleration
                Longitudinal = "0" 'in g's acceleration
            End If

            'Build the output string. (The 'S~' and the '~E' is so the user can see if they have a complete string of inputs)
            Dim WhatToSend As String = "S~Roll:" & Roll & ":Pitch:" & Pitch & ":Yaw:" & Yaw & "RollSpeed:" & RollSpeed & ":PitchSpeed:" & PitchSpeed & ":YawSpeed:" & YawSpeed & "Vertical:" & Vertical & ":Lateral:" & Lateral & ":Longitudinal:" & Longitudinal & "~E"

            'Send the string
            Dim bytCommand As Byte() = New Byte() {}
            bytCommand = Encoding.ASCII.GetBytes(WhatToSend)
            Telemetry_Sender.Send(bytCommand, bytCommand.Length)
        Catch ex As Exception
            'something went wrong, turn off telemetry output.
            Stop_Telemity_Output()
        End Try
    End Sub

    'Stop Telemity Output
    Public Sub Stop_Telemity_Output()
        'only shutdown if already started.
        If Telemetry_Running = True Then
            'turn output off.
            Telemetry_Running = False

            'let it finish what its doing.
            Threading.Thread.Sleep(100)

            'Close Client.
            Telemetry_Sender.Close()
        End If
    End Sub

    'Send Telemetry Loop
    Private Sub Telemetry_Loop()
        'Send Telemetry.
        SendTelemetry()

        'pause till next packet is needed.
        Threading.Thread.Sleep(Telemetry_Loop_ms)

        'loop again if needed.
        If Telemetry_Running = True Then
            Telemetry_Thread = New Threading.Thread(AddressOf Telemetry_Loop)
            Telemetry_Thread.IsBackground = True
            Telemetry_Thread.Start()
        End If
    End Sub
#End Region

End Class
